(* $Id: rpc.mli,v 1.1 1999/04/12 01:23:44 gerd Exp $
 * ----------------------------------------------------------------------
 *
 *)

open Rtypes

type protocol = 
    Tcp          (* means: stream-oriented connection *)
  | Udp;;        (* means: datagram exchange *)

type mode =
    Socket     (* classical server socket *)
  | BiPipe     (* server is endpoint of a bidirectional pipe *)

(* these are error conditions sent to the client: *)

type server_error =
    Unavailable_program                      (* accepted call! *)
  | Unavailable_version of (uint4 * uint4)   (* accepted call  *)
  | Unavailable_procedure                    (* accepted call  *)
  | Garbage                                  (* accepted call  *)
  | Rpc_mismatch of (uint4 * uint4)          (* rejected call  *)
  | Auth_bad_cred                            (* rejected call  *)
  | Auth_rejected_cred                       (* rejected call  *)
  | Auth_bad_verf                            (* rejected call  *)
  | Auth_rejected_verf                       (* rejected call  *)
  | Auth_too_weak                            (* rejected call  *)
;;

exception Rpc_server of server_error;;
  (* an exception generated by the RPC server *)


exception Rpc_cannot_unpack of string;;
  (* RPC protocol error (bad data) *)

(* ======================================================================
 * History:
 * 
 * $Log: rpc.mli,v $
 * Revision 1.1  1999/04/12 01:23:44  gerd
 * 	Initial revision.
 *
 * 
 *)
