#! /bin/sh
# (*
exec /opt/ocaml-2.02/bin/ocamlfattop "$0"
*) directory ".";;

#directory "/opt/ocaml-2.02/site-lib/equeue";;
#directory "/opt/ocaml-2.02/site-lib/rpc";;

#load "equeue.cma";;
#load "rpc.cma";;

open Rpc
open Rtypes
open Xdr
open Unixqueue

(* let prot = Tcp;; *)
let prot = Udp;;

(* let conn = Rpc_client.Unix (Sys.getcwd() ^ "/socket");; *)
(* let conn = Rpc_client.InetNumeric (127,0,0,1,6666);; *)
let conn = 
  let pm = Rpc_portmapper.create_inet "localhost" in
  let port = Rpc_portmapper.getport pm (uint4_of_int 0) (uint4_of_int 0) prot in
  Rpc_portmapper.shut_down pm;
  Rpc_client.InetNumeric (127,0,0,1,port)
;;


(***********************************************************************)


let esys = Unixqueue.create_unix_event_system ();;

let program = 
  Rpc_program.create
    (uint4_of_int 0)
    (uint4_of_int 0)
    (validate_xdr_type_system [])
    [ "SUCC", ((uint4_of_int 42), X_uint, X_uint) ]
;;

let client = Rpc_client.create esys conn prot program;;

for i=1 to 10 do
Rpc_client.add_call client "SUCC" (XV_uint (uint4_of_int (55+i))) 
    (fun get_val -> 
      let XV_uint n = get_val() in
      (* Unix.sleep 2; *)
      print_endline ("got " ^ string_of_int (int_of_uint4 n)))
done
;;

try
  run esys
with
  Unix.Unix_error (e,op,_) ->
    prerr_endline ("Error in " ^ op ^ ":");
    prerr_endline (Unix.error_message e)
;;

