#! /bin/sh
# (*
exec /opt/ocaml-2.02/bin/ocamlfattop "$0"
*) directory ".";;

#directory "/opt/ocaml-2.02/site-lib/equeue";;
#directory "/opt/ocaml-2.02/site-lib/rpc";;

#load "equeue.cma";;
#load "rpc.cma";;

open Rpc
open Rtypes
open Xdr
open Unixqueue

(* let prot = Tcp;; *)
let prot = Udp;;

(* let conn = Rpc_server.Unix (Sys.getcwd() ^ "/socket");; *)
(* let conn = Rpc_server.Localhost 6666;; *)
let conn = Rpc_server.Portmapped;;


(***********************************************************************)

let primitive_handler s descr m group esys esys' ev =
  match ev with
    Input_arrived d ->
      if d <> descr then raise (Equeue.Reject);
      (* force answer *)
      Rpc_server.reply s (XV_uint (uint4_of_int m));
      remove_resource (Rpc_server.get_event_system s) group (Wait_in d)

  | _ ->
      raise (Equeue.Reject)
;;


let succ_invoke s (XV_uint v) =
  let n = int_of_uint4 v in

  let input, output = Unix.pipe() in
  let pid =
    Unix.create_process 
      "/bin/sh" 
      [| "/bin/sh";
         "-c";
	 "sleep 10; echo" |]
      Unix.stdin
      output
      Unix.stderr in

  let esys = Rpc_server.get_event_system s in
  let group = Unixqueue.new_group esys in

  add_handler esys group (primitive_handler s input (n+1) group);
  add_resource esys group (Wait_in input, (-1.0))
;;


(***********************************************************************)


let esys = create_unix_event_system ();;

let program = 
  Rpc_program.create
    (uint4_of_int 0)
    (uint4_of_int 0)
    (validate_xdr_type_system [])
    [ "SUCC", ((uint4_of_int 42), X_uint, X_uint) ]
;;

let procedures =
  [ Rpc_server.Async 
      { Rpc_server.async_name = "SUCC"; 
	Rpc_server.async_invoke = succ_invoke;
      }	
  ] 
;;


try
  let server = 
    Rpc_server.create esys conn prot Socket program procedures 20 in

  run esys
with
  Unix.Unix_error (e,op,_) ->
    prerr_endline ("Error in " ^ op ^ ":");
    prerr_endline (Unix.error_message e)
;;

